'use strict'

const fp = require('fastify-plugin')
const dayjs = require('dayjs')
const advancedFormat = require('dayjs/plugin/advancedFormat.js')
const arraySupport = require('dayjs/plugin/arraySupport.js')
const badMutable = require('dayjs/plugin/badMutable.js')
const buddhistEra = require('dayjs/plugin/buddhistEra.js')
const calendar = require('dayjs/plugin/calendar.js')
const customParseFormat = require('dayjs/plugin/customParseFormat.js')
const dayOfYear = require('dayjs/plugin/dayOfYear.js')
const devHelper = require('dayjs/plugin/devHelper.js')
const duration = require('dayjs/plugin/duration.js')
const isBetween = require('dayjs/plugin/isBetween.js')
const isLeapYear = require('dayjs/plugin/isLeapYear.js')
const isMoment = require('dayjs/plugin/isMoment.js')
const isSameOrAfter = require('dayjs/plugin/isSameOrAfter.js')
const isSameOrBefore = require('dayjs/plugin/isSameOrBefore.js')
const isToday = require('dayjs/plugin/isToday.js')
const isTomorrow = require('dayjs/plugin/isTomorrow.js')
const isYesterday = require('dayjs/plugin/isYesterday.js')
const isoWeek = require('dayjs/plugin/isoWeek.js')
const isoWeeksInYear = require('dayjs/plugin/isoWeeksInYear.js')
const localeData = require('dayjs/plugin/localeData.js')
const localizedFormat = require('dayjs/plugin/localizedFormat.js')
const minMax = require('dayjs/plugin/minMax.js')
const objectSupport = require('dayjs/plugin/objectSupport.js')
const pluralGetSet = require('dayjs/plugin/pluralGetSet.js')
const preParsePostFormat = require('dayjs/plugin/preParsePostFormat.js')
const quarterOfYear = require('dayjs/plugin/quarterOfYear.js')
const relativeTime = require('dayjs/plugin/relativeTime.js')
const timezone = require('dayjs/plugin/timezone.js')
const toArray = require('dayjs/plugin/toArray.js')
const toObject = require('dayjs/plugin/toObject.js')
const updateLocale = require('dayjs/plugin/updateLocale.js')
const utc = require('dayjs/plugin/utc.js')
const weekOfYear = require('dayjs/plugin/weekOfYear.js')
const weekYear = require('dayjs/plugin/weekYear.js')
const weekday = require('dayjs/plugin/weekday.js')

function fastifyDayjs(fastify, _options, next) {
	dayjs.extend(advancedFormat)
	dayjs.extend(arraySupport)
	dayjs.extend(badMutable)
	dayjs.extend(buddhistEra)
	dayjs.extend(calendar)
	dayjs.extend(customParseFormat)
	dayjs.extend(dayOfYear)
	dayjs.extend(devHelper)
	dayjs.extend(duration)
	dayjs.extend(isBetween)
	dayjs.extend(isLeapYear)
	dayjs.extend(isMoment)
	dayjs.extend(isSameOrAfter)
	dayjs.extend(isSameOrBefore)
	dayjs.extend(isToday)
	dayjs.extend(isTomorrow)
	dayjs.extend(isYesterday)
	dayjs.extend(isoWeek)
	dayjs.extend(isoWeeksInYear)
	dayjs.extend(localeData)
	dayjs.extend(localizedFormat)
	dayjs.extend(minMax)
	dayjs.extend(objectSupport)
	dayjs.extend(pluralGetSet)
	dayjs.extend(preParsePostFormat)
	dayjs.extend(quarterOfYear)
	dayjs.extend(relativeTime)
	dayjs.extend(timezone)
	dayjs.extend(toArray)
	dayjs.extend(toObject)
	dayjs.extend(updateLocale)
	dayjs.extend(utc)
	dayjs.extend(weekOfYear)
	dayjs.extend(weekYear)
	dayjs.extend(weekday)
	fastify.decorate('dayjs', dayjs)
	next()
}

module.exports = fp(fastifyDayjs, {
	fastify: '4.x',
	name: 'fastify-dayjs',
})

module.exports.dayjs = dayjs
